#ifndef MAIN_H
#define MAIN_H
#include <memory>
#include <iostream>

class CSingleLinkedList {
    
    struct Node {
        double data;
        std::unique_ptr<Node> next;
        
    };
    
    std::unique_ptr<Node> head;
    int Size;
    
public:
    Node* getHead() const { return head.get(); }
    
    
    // Конструктори/деструктор
    CSingleLinkedList() : Size(0) {}
    CSingleLinkedList(double value) : head(std::make_unique<Node>(Node{ value, nullptr })), Size(1) {}
    CSingleLinkedList(const CSingleLinkedList& other);
    CSingleLinkedList(CSingleLinkedList&& other) noexcept;
    ~CSingleLinkedList() = default;
    
    
    // Оператори присвоєння/переміщення
    CSingleLinkedList& operator=(const CSingleLinkedList& other);
    CSingleLinkedList& operator=(CSingleLinkedList&& other) noexcept;
    
    // Методи класу
    CSingleLinkedList addToBegin(double value);
    CSingleLinkedList removeFirst();
    CSingleLinkedList addAfter(double value, int AfterElem);
    int getSize() const;
    double getMaxValue() const;
    double getMinValue() const;
    void selectionSorted(bool methodSort);
    
    // Перегрузка операторів
    CSingleLinkedList operator+(const CSingleLinkedList& data);
    CSingleLinkedList operator-(const CSingleLinkedList& data);
    CSingleLinkedList operator*(double scalar);
    friend std::istream& operator>>(std::istream& input, CSingleLinkedList& list);
    friend std::ostream& operator<<(std::ostream& output, const CSingleLinkedList& list);
    double operator[]( int index);
};
#endif // MAIN_H
